/***
 * React scripts
 */

const settings = window.wc.wcSettings.getSetting('opay_data', {});
const label = window.wp.htmlEntities.decodeEntities(settings.title) || window.wp.i18n.__('Apmokėkite populiariausiais mokėjimo būdais', 'woo-custom-payment-method-for-woo-blocks');

const Content = (props) => {
    const { eventRegistration, emitResponse } = props;
    const { onPaymentProcessing } = eventRegistration;
    React.useEffect(() => {
        const unsubscribe = onPaymentProcessing(async () => {
            const selected_channel = jQuery('#opay_selected_channel').val();
            if (settings.in_external_opay_page == false) {
                if (selected_channel) {
                    return {
                        type: emitResponse.responseTypes.SUCCESS,
                        meta: {
                            paymentMethodData: {
                                selected_channel,
                            },
                        },
                    };
                }

                return {
                    type: emitResponse.responseTypes.ERROR,
                    message: window.wp.i18n.__('Please choose payment method', 'opay-woocommerce'),
                };
            } else {
                const selected_channel = 'no-channel';

                return {
                    type: emitResponse.responseTypes.SUCCESS,
                    meta: {
                        paymentMethodData: {
                            selected_channel,
                        },
                    },
                };
            }

        });
        return () => {
            unsubscribe();
        };
    }, [
        emitResponse.responseTypes.ERROR,
        emitResponse.responseTypes.SUCCESS,
        onPaymentProcessing
    ]);
    /* Content */
    var description = React.createElement('p', null, window.wp.htmlEntities.decodeEntities(settings.description || ''));

    var opay_selected_channel = React.createElement('input', {
        type: 'hidden',
        name: 'opay_selected_channel',
        id: 'opay_selected_channel',
        required: false,
    });

    var opay_available_payments_list = React.createElement('div', {
        id: 'opay-available-payments-list',
    });

    return React.createElement('div', null, description, opay_selected_channel, opay_available_payments_list);
};

const Opay_Block_Gateway = {
    name: 'opay',
    label: label,
    content: React.createElement(Content, null),
    edit: React.createElement(Content, null),
    icons: null,
    canMakePayment: () => true,
    ariaLabel: label,
    supports: {
        features: settings.supports,
    },
};

window.wc.wcBlocksRegistry.registerPaymentMethod(Opay_Block_Gateway);

/***
 * jQuery scripts
 */

jQuery(document).ready(function () {

    window.setInterval(function () {
        jQuery(".wp-block-woocommerce-checkout-payment-block #opay-available-payments-list ul").each(function (index) {
            jQuery(this).find(".opay-payment-item").each(function (index) {
                jQuery(this).click(function () {
                    var selected_channel = jQuery(this).find('input[name="channel"]');
                    jQuery('#opay_selected_channel').val(selected_channel.val());
                });
                var selected_channel = jQuery(this).find('input[name="channel"]');
                var selected_payment_method = jQuery("#opay_selected_channel").val();

                if (selected_payment_method == selected_channel.val()) {
                    jQuery(this).find('label').addClass('seleceted-opay-payment-method');
                    selected_channel.attr('checked', true);
                    selected_channel.css('background-color', 'var(--wp--preset--color--primary)');
                    selected_channel.css('border-color', 'var(--wp--preset--color--primary)');
                } else {
                    jQuery(this).find('label').removeClass('seleceted-opay-payment-method');
                    selected_channel.removeAttr('checked');
                    selected_channel.css('background-color', 'unset');
                    selected_channel.css('border-color', 'unset');
                    selected_channel.css('background-image', 'unset');
                }});
        });

    }, 50);

    setTimeout(function () {
        jQuery(".wp-block-woocommerce-checkout-payment-block .wc-block-components-checkout-step__container .wc-block-components-radio-control-accordion-option").each(function (index) {
            var payment_method = jQuery(this);
            var payment_method_label = jQuery(this).find('label.wc-block-components-radio-control__option');

            payment_method_label.click(function () {
                setTimeout(function () {
                    var content_elements = jQuery('#payment-opay-methods-list').clone();
                    payment_method.find('#opay-available-payments-list').html(content_elements);
                    jQuery('#opay-available-payments-list #payment-opay-methods-list').css('display', 'block');
                }, 200);
            });

        });
    }, 500);
    setTimeout(function () {
        var content_elements = jQuery('#payment-opay-methods-list').clone();
        jQuery('.wc-block-components-radio-control-accordion-option #opay-available-payments-list').html(content_elements);
        jQuery('#opay-available-payments-list #payment-opay-methods-list').css('display', 'block');
    }, 500);

});
